﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Linq.Expressions;
using System.Collections.ObjectModel;
using System.Diagnostics;
using Infragistics.Windows.Editors;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window, INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged = delegate { };

        private ObservableCollection<Sample> _myData;
        public ObservableCollection<Sample> MyData
        {
            get
            {
                return _myData;
            }
            set
            {
                if (value != _myData)
                {
                    _myData = value;
                    PropertyChanged(this, new PropertyChangedEventArgs("MyData"));
                }
            }
        }
        

        public MainWindow()
        {
            InitializeComponent();
            grid.EditModeEnding += new EventHandler<Infragistics.Windows.DataPresenter.Events.EditModeEndingEventArgs>(grid_EditModeEnding);
            //grid.EditModeEnded += new EventHandler<Infragistics.Windows.DataPresenter.Events.EditModeEndedEventArgs>(grid_EditModeEnded);
            this.Loaded += new RoutedEventHandler(MainWindow_Loaded);
        }

        //void grid_EditModeEnded(object sender, Infragistics.Windows.DataPresenter.Events.EditModeEndedEventArgs e)
        //{
        //    e.Handled = true;
        //    Debug.WriteLine("grid_EditModeEnded");
        //}

void grid_EditModeEnding(object sender, Infragistics.Windows.DataPresenter.Events.EditModeEndingEventArgs e)
{
    if (e.Cell.Field.Name == "Remove" && (bool)e.Editor.Value) 
    {
        ///////////////////////////////////////////////////////////////////////////////////////
        //BUGBUG:: This is not working as expected. Maybe my logic is incorrect. Could you help?
        ///////////////////////////////////////////////////////////////////////////////////////
        if (MessageBoxResult.No == MessageBox.Show("Click Yes if you are sure and No to cancel", "Are you sure?", MessageBoxButton.YesNo))
        {
            e.AcceptChanges = false;

            // NOTE: If this is uncommented, the edit mode does not end
            //e.Cancel = !e.AcceptChanges;
        }

        Debug.WriteLine("grid_EditModeEnding");
    }
}

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            MyData = new ObservableCollection<Sample>();
            MyData.Add(new Sample { Name = "AAA" });
            MyData.Add(new Sample { Name = "BBB" });
            MyData.Add(new Sample { Name = "CCC" });
            MyData.Add(new Sample { Name = "DDD" });
        }


        void cValueChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            XamCheckEditor editor = sender as XamCheckEditor;
            editor.EndEditMode(true, false);
        }
    }
}